var serial; 
var portName = 'COM11';

var inData;
var outData = 'C';
var redValue;
var greenValue;
var blueValue;

let video;

function setup() {
  createCanvas(640 , 480);

  video = createCapture(VIDEO);
  
  serial = new p5.SerialPort();
  serial.on('list', printList);
  serial.on('connected', serverConnected); // callback for connecting to the server
  serial.on('open', portOpen);        // callback for the port opening
  serial.on('data', serialEvent);     // callback for when new data arrives
  serial.on('error', serialError);    // callback for errors
  serial.on('close', portClose);      // callback for the port closing
 
  serial.list();                      // list the serial ports
  serial.open(portName); 
}

function draw() {
  inData = serial.read();
  image(video, 0,0, width, height);
  frameRate(inData);
  
  screenColor = video.get(mouseX, mouseY);
  fill(screenColor);
  rect(25, 25, 50, 50);
  redValue = red(screenColor);
  greenValue = green(screenColor);
  blueValue = blue(screenColor);
  console.log("R: " + redValue);
  console.log("G: " + greenValue);
  console.log("B: " + blueValue);
  
  serial.write(outData);
  serial.write(redValue);
  serial.write(greenValue);
  serial.write(blueValue);
}  

function printList(portList) {
  for (var i = 0; i < portList.length; i++) {
    console.log(i + " " + portList[i]);
  }
}

function serverConnected() {
  console.log('connected to server.');
}
 
function portOpen() {
  console.log('the serial port opened.')
}
 
function serialEvent() {
  var data = serial.read();
  // console.log(data);
  circleSize = data;
}
 
function serialError(err) {
  console.log('Something went wrong with the serial port. ' + err);
}
 
function portClose() {
  console.log('The serial port closed.');
}